package config

import (
	"time"

	"github.com/lestrrat-go/backoff"
)

var ServerName string = "Hoernschen's Matrix Server"
var Version string = "0.1"

var Homeserver string
var Port string

var PrivateKey []byte
var PublicKey []byte
var KeyId string
var VerifyKeys map[string]map[string][]byte

var Packetloss int
var UnavailableTill int64
var Consensus bool
var AuthentificationCheck bool
var Signing bool
var Encryption bool
var HttpString string

var BackoffPolicy *backoff.Exponential

func SetDefaultParams() {
	Packetloss = 0.0
	UnavailableTill = time.Now().Unix()
	Consensus = true
	AuthentificationCheck = true
	Signing = true
	Encryption = true
	HttpString = "https"
}
