package device

type Key struct {
	Id   string `json:"id,omitempty"`
	Type string `json:"type,omitempty"`
	Key  []byte `json:"key,omitempty"`
}

type ServerKeys struct {
	ServerName    string                       `json:"server_name,omitempty"`
	VerifyKeys    map[string]verifyKey         `json:"verify_keys,omitempty"`
	OldVerifyKeys map[string]verifyKey         `json:"old_verify_keys,omitempty"`
	Signatures    map[string]map[string]string `json:"signatures,omitempty"`
	ValidUntil    int64                        `json:"valid_until_ts,omitempty"`
}

type verifyKey struct {
	Key     string `json:"key,omitempty"`
	Expired int64  `json:"expired_ts,omitempty"`
}
